# FIXME BUG: two-domain manual mesh

from netgen.meshing import *
# pml xy mesh
def meshPMLXY(xmin, xmax, ymin, ymax, Nx, Ny, layerX, layerY) :
    ngmesh = Mesh()
    ngmesh.dim = 2
    hx = (xmax-xmin)/Nx
    hy = (ymax-ymin)/Ny
    
    x0 = xmin-layerX*hx
    x1 = xmin
    x2 = xmax
    x3 = xmax+layerX*hx

    y0 = ymin-layerY*hy
    y1 = ymin
    y2 = ymax
    y3 = ymax+layerY*hy
    
    Ny1 = layerY
    Ny2 = Ny
    Ny12 = Ny1+Ny2
    Ny3 = layerY
    
    Nx1 = layerX
    Nx2 = Nx
    Nx12 = Nx1+Nx2
    Nx3 = layerX
    
    Ny = Ny1+Ny2+Ny3
    Nx = Nx1+Nx2+Nx3
    
    pnums = []
    for i in range(Nx + 1):
        for j in range(Ny + 1):
            pnums.append(ngmesh.Add(MeshPoint(Pnt(xmin + hx*i , ymin + hy*j,0))))
    
    
    # inner
    ngmesh.Add (FaceDescriptor(surfnr=1,domin=1,bc=1))
    # pmlx
    ngmesh.Add (FaceDescriptor(surfnr=2,domin=1,bc=1))
    # pmly
    ngmesh.Add (FaceDescriptor(surfnr=3,domin=1,bc=1))
    # pmlxy
    ngmesh.Add (FaceDescriptor(surfnr=4,domin=1,bc=1))
    
    for i in range(Nx):
        for j in range(Ny):
            if j < Ny1 and i < Nx1 :
                id1 = 4 # bottom left
            elif j < Ny1 and i < Nx12 :
                id1 = 3 # bottom middle
            elif j < Ny1  :
                id1 = 4 # bottom middl
            elif j < Ny12 and i < Nx1:
                id1 = 2
            elif j < Ny12 and i < Nx12:
                id1 = 1
            elif j < Ny12 :
                id1 = 2
            elif j < Ny and i < Nx1:
                id1 = 4
            elif j < Ny and i < Nx12:
                id1 = 3
            else :
                id1 = 4
    
            ngmesh.Add(Element2D(id1, [pnums[j + i * (Ny + 1)],
                pnums[j + (i + 1) * (Ny + 1)],
                pnums[j + 1 + (i + 1) * (Ny + 1)],
                pnums[j + 1 + i * (Ny + 1)]]))
    
    # horizontal boundaries
    for i in range(Nx):
       ngmesh.Add(Element1D([pnums[0 + i * (Ny + 1)], pnums[0 + (i + 1) * (Ny + 1)]], index=1))
       ngmesh.Add(Element1D([pnums[Ny1 + i * (Ny + 1)], pnums[Ny1 + (i + 1) *
           (Ny + 1)]], index=5))
       ngmesh.Add(Element1D([pnums[Ny1+Ny2 + i * (Ny + 1)], pnums[Ny1+Ny2 + (i
           + 1) * (Ny + 1)]], index=5))
       ngmesh.Add(Element1D([pnums[Ny + i * (Ny + 1)], pnums[Ny + (i + 1) * (Ny
         + 1)]], index=3))
    
    # vertial boundaries
    for i in range(Ny):
       ngmesh.Add(Element1D([pnums[i], pnums[i + 1]], index=4))
       ngmesh.Add(Element1D([pnums[i+Nx1*(Ny+1)], pnums[i + 1+Nx1*(Ny+1)]],
           index=5))
       ngmesh.Add(Element1D([pnums[i+Nx12*(Ny+1)], pnums[i + 1+Nx12*(Ny+1)]],
           index=5))
       ngmesh.Add(Element1D([pnums[i + Nx * (Ny + 1)], pnums[i + 1 + Nx * (Ny + 1)]], index=2))
    
    ngmesh.SetMaterial(1, "inner")
    ngmesh.SetMaterial(2, "pmlx")
    ngmesh.SetMaterial(3, "pmly")
    ngmesh.SetMaterial(4, "pmlxy")
    
    ngmesh.SetBCName(0, "pec")
    ngmesh.SetBCName(1, "pec")
    ngmesh.SetBCName(2, "pec")
    ngmesh.SetBCName(3, "inflow")
    ngmesh.SetBCName(4, "interface")
    return ngmesh

ngmesh = meshPMLXY(0,1,0,1,1,1,1,1) 

from ngsolve import *
mesh = Mesh(ngmesh)
V1 = L2(mesh, definedon=mesh.Materials("inner"))
V2 = L2(mesh, definedon=mesh.Materials("pmlx"))

print(V1.FreeDofs())
print(V2.FreeDofs())
